﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Accion_Boton : MonoBehaviour
{
    #region public variables
    public GameObject puertas;
    public Material Rojo;
    public Material Verde;
    #endregion

    #region private variables
    private float step;
    private float velocidad;
    private int direccion;
    private bool movimiento;
    #endregion


    // Start is called before the first frame update
    void Start()
    {
        velocidad = 1f;
        movimiento = false;
        direccion = 0;
    }

    // Update is called once per frame
    void Update()
    {
        ActivarPuertas();
    }

    #region #FUNCIONES#
    public void ActivarPuertas()
    {
        if (movimiento) //Si he accionado el boton y las puertas se deben mover
        {
            step = velocidad * Time.deltaTime; //Calculo Movimiento
            foreach (Transform puerta in puertas.transform) //Por cada Puerta que mueve el boton que acabo de pulsar
            {
                Transform model = puerta.Find("model_Puerta"); //Seleccion el modelo
                Transform posInicial = puerta.Find("posInicio"); //Selecciono la posicion inicial
                Transform posFinal = puerta.Find("posFinal"); //Selecciono la posicion final

                if (direccion == 0) //Control de la direccion en la que tiene que ir la puerta
                {
                    model.position = Vector3.MoveTowards(model.position, posFinal.position, step); //Se mueve la puerta en esa direccion
                    this.GetComponent<MeshRenderer>().material = Verde; //Pone el material del boton en verde
                }
                else
                {
                    model.position = Vector3.MoveTowards(model.position, posInicial.position, step); //Se mueve la puerta en esa direccion
                    this.GetComponent<MeshRenderer>().material = Rojo; //Pone el material del boton en rojo
                }

                if(model.position == posInicial.position || model.position == posFinal.position) //Cuando la puerta alcanza su objetivo (ya sea el inicial o el final)
                {
                    movimiento = false; //Deja de moverse la puerta
                    cambiarDireccion(); //Cambia la direccion para cuando se vuelva a pulsar el boton
                }
            }
        }
    }

    //Activa el movimiento de las puertas//
    public void ActivarMovimiento() 
    {
        movimiento = true; 
    }

    //Cambia de direccion hacia donde se va a mover las puertas//
    private void cambiarDireccion() 
    {
        if (direccion == 0)
        {
            direccion = 1;
        }
        else
        {
            direccion = 0;
        }
    }

    //Reinicia las puertas a su posicion inicial//
    public void resetearPosicion()
    {
        foreach (Transform puerta in puertas.transform)
        {
            Transform model = puerta.Find("model_Puerta");
            Transform posInicial = puerta.Find("posInicio");

            model.transform.position = posInicial.transform.position;
            this.GetComponent<MeshRenderer>().material = Rojo;
        }
        direccion = 0;
        movimiento = false;
    }

    #endregion
}
