﻿using System.Collections;
using System.Collections.Generic;
using System;
using UnityEngine;
using UnityEngine.UI;
using GoogleMobileAds.Api;
using UnityEngine.Events;

public class ControlAnuncios : MonoBehaviour
{
    #region public variables
    public event EventHandler<EventArgs> OnAdLoaded;
    public event EventHandler<EventArgs> OnAdFailedToLoad;
    public event EventHandler<EventArgs> OnAdOpening;
    public event EventHandler<EventArgs> OnAdFailedToShow;
    public event EventHandler<EventArgs> OnUserEarnedReward;
    public event EventHandler<EventArgs> OnAdClosed;

    public GameObject Player;
    #endregion

    #region private variables
    private string ADD_ID = "ca-app-pub-2127695310858464~2184581222"; //ID ADD APP
    private string rewarded_ad_ID = "ca-app-pub-3940256099942544/5224354917"; //ANUNCIOS DE PRUEBA REWARDED;
    //private string rewarded_ad_ID = "ca-app-pub-2127695310858464/3306091209"; //CODIGO DE MIS ANUNCIOS
    private RewardedAd rewardedAd;
    private RewardBasedVideoAd rewardBasedVideo;
    #endregion

    // Start is called before the first frame update
    void Start()
    {
        MobileAds.Initialize(initStatus => { });

        CreateAndLoadRewardedAd(); //Al iniciar creo un anuncio rewarded

    }

    public void CreateAndLoadRewardedAd()
    {
        rewardedAd = new RewardedAd(rewarded_ad_ID);

        // Called when an ad request has successfully loaded.
        rewardedAd.OnAdLoaded += HandleRewardedAdLoaded;
        // Called when an ad request failed to load.
        rewardedAd.OnAdFailedToLoad += HandleRewardedAdFailedToLoad;
        // Called when an ad is shown.
        rewardedAd.OnAdOpening += HandleRewardedAdOpening;
        // Called when an ad request failed to show.
        rewardedAd.OnAdFailedToShow += HandleRewardedAdFailedToShow;
        // Called when the user should be rewarded for interacting with the ad.
        rewardedAd.OnUserEarnedReward += HandleUserEarnedReward;
        // Called when the ad is closed.
        rewardedAd.OnAdClosed += HandleRewardedAdClosed;

        // Create an empty ad request.
        AdRequest request = new AdRequest.Builder().Build();
        // Load the rewarded ad with the request.
        rewardedAd.LoadAd(request);

    }

    public void ShowVideoRewarded()
    {
        if (rewardedAd.IsLoaded())
        {
            rewardedAd.Show();
        }
    }

    public void HandleRewardedAdLoaded(object sender, EventArgs args) //ANUNCIO CARGADO
    {
        MonoBehaviour.print("HandleRewardedAdLoaded event received");
    }

    public void HandleRewardedAdFailedToLoad(object sender, AdErrorEventArgs args) //ERROR AL CARGAR ANUNCIO
    {
        MonoBehaviour.print(
            "HandleRewardedAdFailedToLoad event received with message: "
                             + args.Message);
        CreateAndLoadRewardedAd(); //Cargar otro anuncio
    }

    public void HandleRewardedAdOpening(object sender, EventArgs args) //ANUNCIO ABIERTO
    {
        MonoBehaviour.print("HandleRewardedAdOpening event received");
    }

    public void HandleRewardedAdFailedToShow(object sender, AdErrorEventArgs args) //ERROR AL MOSTRAR ANUNCIO
    {
        MonoBehaviour.print(
            "HandleRewardedAdFailedToShow event received with message: "
                             + args.Message);
        CreateAndLoadRewardedAd(); //Cargar otro anuncio
    }

    public void HandleRewardedAdClosed(object sender, EventArgs args) //ANUNCIO CERRADO
    {
        MonoBehaviour.print("HandleRewardedAdClosed event received");
        CreateAndLoadRewardedAd(); //Cargar otro anuncio
    }

    public void HandleUserEarnedReward(object sender, Reward args) //DAR PREMIO
    {
        string type = args.Type;
        double amount = args.Amount;
        MonoBehaviour.print(
            "HandleRewardedAdRewarded event received for "
                        + amount.ToString() + " " + type);

        sumarRecompensa(type, amount); //Sumar recompensa
        CreateAndLoadRewardedAd(); //Cargar otro anuncio
    }

    private void sumarRecompensa(string type, double amount)
    {
        if(type == "Monedas") //Si es recompensa en monedas
        {
            Player.GetComponent<Controlar_PuntuacionNivel>().recompensaVideo(); //Cargo las monedas extras (x3 de las monedas ganadas)
            //this.GetComponent<ControladorGeneral>().sumarMonedas(amount);
        }
    }
}
