﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.EventSystems;
using System;
using TMPro;

public class ControlMenu : MonoBehaviour
{

    #region public variables
    public GameObject _config; //_config.transform.GetComponent<SCRIPT>().FUNCION     CONTROLADOR GENERAL
    public GameObject Niveles;
    public GameObject Menu;
    public GameObject selectLVL;
    public GameObject options;
    public GameObject inicial;
    public GameObject skins;
    public GameObject FinalNivel;
    public GameObject HudPartida;
    public GameObject Pause;
    public GameObject BackToMenu;

    public GameObject Player;
    public Camera CameraMenu;
    public Camera CameraPlayer;

    public TextMeshProUGUI monedas;
    #endregion

    #region private variables
    private bool gameStart;
    private Transform nivel;
    #endregion

    private void Start()
    {
        //Activo/desactivo los menus para dejarlos en el esatdo incial//
        inicial.SetActive(true);
        selectLVL.SetActive(false);
        skins.SetActive(false);
        options.SetActive(false);
        Player.SetActive(false);
        HudPartida.SetActive(false);
        BackToMenu.SetActive(false);

        gameStart = false; //El juego no a empezado

        int nivel = _config.transform.GetComponent<ControladorGeneral>().getNivelSeleccionado(); //Recupero el nivel seleccionado
        Niveles.gameObject.transform.Find("Nivel_" + nivel).gameObject.SetActive(true); //Busco el nivel seleccionado y lo activo (el fondo del menu principal)
        actualizarMonedas();
    }

    //Devuelve true/false si el juego esta en partida o no
    public bool isGameStart()
    {
        return gameStart;
    }


    private void Update()
    {
        //actualizarMonedas();
    }

    //Recupero las monedas actuales y modifico el texto de la pantalla
    private void actualizarMonedas()
    {
        monedas.text = Convert.ToString(_config.transform.GetComponent<ControladorGeneral>().getMonedas());
    }

    //Inicio la partida
    public void onPressPLAY()
    {
        _config.transform.GetComponent<ControladorGeneral>().SaveGame(); //GUARDO EL JUEGO CON LAS OPCIONES SELECCIONADAS
        gameStart = true; //Inicio la partida
        nivel = Niveles.transform.Find("Nivel_" + _config.transform.GetComponent<ControladorGeneral>().getNivelSeleccionado()); //Selecciono el nivel
        //START GAME//
        nivel.gameObject.SetActive(true); //Activo el nivel (por si acaso)
        nivel.GetComponent<cargarNivel>().reiniciarElNivel(); //Reinicio el nivel (por si acaso)
        Menu.gameObject.SetActive(false); //Desactivo menu
        HudPartida.SetActive(true); //Activo el hud de la partida
        Player.SetActive(true); //Activo al jugador
        this.GetComponent<selectSkin>().ActivateSkin(); //Activo la skin del jugador
        CameraMenu.gameObject.SetActive(false); //Desactivo la camara del menu
        CameraPlayer.gameObject.SetActive(true); //Activo la camara de la partida
    }

    //Selecciono un nuevo nivel en el menu
    public void onSelectOneLVL()
    {
        int nivelAnteior = _config.transform.GetComponent<ControladorGeneral>().getNivelSeleccionado(); //Selecciono nivel anterior
        int nivel = Convert.ToInt32(EventSystem.current.currentSelectedGameObject.name); //Selecciono nuevo nivel

        _config.transform.GetComponent<ControladorGeneral>().setNivel(nivel); //Guardo el nivel seleccionado

        selectLVL.transform.Find("Marco").transform.position = selectLVL.transform.Find(_config.transform.GetComponent<ControladorGeneral>().getNivelSeleccionado().ToString()).transform.position; //Pongo el marco encima del nivel seleccionado

        Niveles.gameObject.transform.Find("Nivel_" + nivelAnteior).gameObject.SetActive(false); //Desactivo nivel anterior
        Niveles.gameObject.transform.Find("Nivel_" + nivel).gameObject.SetActive(true); //Activo nivel actual

        Transform nivelActual = Niveles.transform.Find("Nivel_" + _config.transform.GetComponent<ControladorGeneral>().getNivelSeleccionado()); //Selecciono el nivel actual
        nivelActual.GetComponent<cargarNivel>().reiniciarElNivel(); //Reinicio el nivel actual

        Niveles.transform.Find("CameraMap").GetComponent<RotateAroundTarget>().selectNivel(); //Giro la camara del menu en torno al nuevo nivel
    }

    //Activo el menu de seleccionar nivel
    public void onPressLVL()
    {
        inicial.SetActive(false); //Desactivo menu inicial
        selectLVL.SetActive(true); //Activo menu niveles
        skins.SetActive(false); //Desactivo menu skins
        options.SetActive(false); //Desactivo menu opciones
        BackToMenu.SetActive(true); //Activo la vuelta atras

        for (int x = 1; x <= _config.transform.GetComponent<ControladorGeneral>().getNivelMaximo(); x++) //Por cada nivel que tengo hasta el nivel maximo
        {
            selectLVL.transform.Find(Convert.ToString(x)).GetComponent<Button>().interactable = true; //Lo activo para que se pueda seleccionar
        }
        selectLVL.transform.Find("Marco").transform.position = selectLVL.transform.Find(_config.transform.GetComponent<ControladorGeneral>().getNivelSeleccionado().ToString()).transform.position; //Pongo el marco en el nivel seleccionado

    }

    //Vuelvo al menu inicial
    public void onPressBack()
    {
        inicial.SetActive(true); //Activo menu inicial
        selectLVL.SetActive(false); //Desactivo menu seleccionar nivel
        skins.SetActive(false); //Desactivo menu skins
        options.SetActive(false); //Desactivo menu opcioens
        HudPartida.SetActive(false); //Desactivo hud partida
        BackToMenu.SetActive(false); //Desactivo boton volver atras
        mostrarNivel();
    }

    //Activo el menu opciones
    public void onPressOptions()
    {
        inicial.SetActive(false); //Desactivo menu inicial
        selectLVL.SetActive(false); //Desactivo menu seleccionar nivel
        skins.SetActive(false); //Desactivo menu seleccionar skins
        options.SetActive(true); //Activo menu opciones
        BackToMenu.SetActive(true); //Activo boton volver atras
        ocultarNivel();
    }

    //Pongo el marco en la skin seleccionada
    public void onSelectSkin()
    {
        skins.transform.Find("Marco").transform.position = skins.transform.Find(_config.transform.GetComponent<ControladorGeneral>().getSkinActual().ToString()).transform.position;
    }
    
    //Activo el menu skins
    public void onPressSkins()
    {
        inicial.SetActive(false); //Desactivo menu inicial
        selectLVL.SetActive(false); //Desactivo menu seleccionar nivel
        options.SetActive(false); //Desactivo menu opciones
        skins.SetActive(true); //Activo menu seleccionar skins
        BackToMenu.SetActive(true); //Activo boton volver atras

        ocultarNivel();

        foreach (int skin in _config.transform.GetComponent<ControladorGeneral>().getSkinsDesbloqueadas()) //Por cada skin que tengo desbloqueada
        {
            skins.transform.Find(skin.ToString()).gameObject.transform.Find("price").gameObject.SetActive(false); //Ya no se puede comprar
            skins.transform.Find(skin.ToString()).GetComponent<Button>().interactable = true; //Activo el boton para seleccionar skin
        }
        skins.transform.Find("Marco").transform.position = skins.transform.Find(_config.transform.GetComponent<ControladorGeneral>().getSkinActual().ToString()).transform.position; //Pongo el marco en la skin seleccionada
    }

    private void ocultarNivel() //Oculto el nivel
    {
        int nivel = _config.transform.GetComponent<ControladorGeneral>().getNivelSeleccionado(); //Selecciono el nivel actual
        Niveles.gameObject.transform.Find("Nivel_" + nivel).gameObject.SetActive(false); //Lo oculto para que no moleste para seleccionar skin
        Player.gameObject.SetActive(false);
    }
    private void mostrarNivel() //Muestro el nivel
    {
        int nivel = _config.transform.GetComponent<ControladorGeneral>().getNivelSeleccionado(); //Selecciono el nivel actual
        Niveles.gameObject.transform.Find("Nivel_" + nivel).gameObject.SetActive(true); //Lo oculto para que no moleste para seleccionar skin
        Player.gameObject.SetActive(true);
    }

    //Poner pausa a la partida
    public void onPressPause()
    {
        Time.timeScale = 0; //Deja de correr el tiempo
        Player.GetComponent<Movimiento_Jugador>().switchPausa();
        Pause.SetActive(true); //Se activa menu pausa
    }

    //Salir modo pausa
    public void onPressResume()
    {
        Time.timeScale = 1; //Vuelve a correr el tiempo
        Player.GetComponent<Movimiento_Jugador>().switchPausa();
        Pause.SetActive(false); //Se desactiva menu pausa 
    }

    //Activo menu inicial
    public void onPressMenu()
    {
        Time.timeScale = 1; //Activo el tiempo
        gameStart = false; //No estoy en partida
        _config.transform.GetComponent<ControladorGeneral>().sumarMonedas(Player.GetComponent<Controlar_PuntuacionNivel>().getMonedas()); //Sumo las monedas que he ganado en el nivel
        Pause.SetActive(false); //Desactivo menu pausa
        selectLVL.SetActive(false); //Desactivo menu seleccionar nivel
        skins.SetActive(false); //Desactivo menu seleccionar skin
        options.SetActive(false); //Desactivo menu opciones
        FinalNivel.SetActive(false); //Desactivo menu final nivel
        HudPartida.SetActive(false); //Deasctivo hud partida
        BackToMenu.SetActive(false); //Desactivo boton atras
        Menu.SetActive(true); //Activo menu principal
        inicial.SetActive(true); //Activo menu incial
        CameraMenu.gameObject.SetActive(true); //Activo camara menu
        CameraPlayer.gameObject.SetActive(false); //Desactivo camara partida
        
        Transform nivelActual = Niveles.transform.Find("Nivel_" + _config.transform.GetComponent<ControladorGeneral>().getNivelSeleccionado()); //Selecciono nivel actual
        nivelActual.GetComponent<cargarNivel>().reiniciarElNivel(); //Reinicio el nivel actual

        Niveles.transform.Find("CameraMap").GetComponent<RotateAroundTarget>().selectNivel(); //La camara del menu apunta al centro del mapa actual
        actualizarMonedas(); //Actualizo monedas del menu
    }

    //Activo menu final nivel
    public void mostrarFinalNivel()
    {
        FinalNivel.SetActive(true); //Activo menu final nivel
        HudPartida.SetActive(false); //Desactivo hud partida
        FinalNivel.transform.Find("Multiplicador").gameObject.SetActive(true); //Muestro el multiplicador
        FinalNivel.transform.Find("Monedas").GetComponent<TextMeshProUGUI>().SetText(Convert.ToString(Player.GetComponent<Controlar_PuntuacionNivel>().getMonedas())); //Monedas que se muestran en pantalla
        _config.transform.GetComponent<ControladorGeneral>().desbloquearNivel(); //Desbloquear siguiente nivel
    }

    //Recarga los puntos de la pantalla Final de nivel
    public void recargarPuntos()
    {
        FinalNivel.transform.Find("Monedas").GetComponent<TextMeshProUGUI>().SetText(Convert.ToString(Player.GetComponent<Controlar_PuntuacionNivel>().getMonedas()));
    }

    //Mostrar anuncio
    public void CargarAnuncio()
    {
        _config.transform.GetComponent<ControlAnuncios>().ShowVideoRewarded();
        FinalNivel.transform.Find("Multiplicador").gameObject.SetActive(false); //Desactivo el multiplicador para que no se abuse de el
    }

    //Multiplicar premio (vieno anuncio)
    public void multiplicarPremio()
    {
        CargarAnuncio();
    }

    //Ir al siguiente nivel
    public void SiguienteNivel()
    {
        _config.transform.GetComponent<ControladorGeneral>().sumarMonedas(Player.GetComponent<Controlar_PuntuacionNivel>().getMonedas()); //Guardo las monedas conseguidas en este nivel
        _config.transform.GetComponent<ControladorGeneral>().nextLvl(); //Seleccino siguiente nivel
        FinalNivel.SetActive(false); //Deactivo menu Final nivel

        _config.transform.GetComponent<ControladorGeneral>().SaveGame(); //GUARDO EL JUEGO CON LAS OPCIONES SELECCIONADAS
        Transform nivel = Niveles.transform.Find("Nivel_" + _config.transform.GetComponent<ControladorGeneral>().getNivelSeleccionado()); //Selecciono el nivel actual
        Transform nivelAnterior = Niveles.transform.Find("Nivel_" + (_config.transform.GetComponent<ControladorGeneral>().getNivelSeleccionado() - 1)); //Selecciono el nivel anterior

        nivel.GetComponent<cargarNivel>().reiniciarElNivel(); //Reinicio el nivel actual
        //ACTIVAR NUEVO NIVEL//
        nivelAnterior.gameObject.SetActive(false); //Desactivo nivel anterior
        nivel.gameObject.SetActive(true); //Activo nivel actual
        HudPartida.SetActive(true); //Activo hud partida
    }

    //Si tiene monedas desbloquea skin seleccionada
    public void comprarSkin(int price)
    {
        var CG = _config.GetComponent<ControladorGeneral>(); //Selecciono el controlador general
        GameObject botonPulsado = EventSystem.current.currentSelectedGameObject; //Seleccionar boton pulsado

        if (CG.getMonedas() >= price) //Si tengo dinero suficiente
        {
            CG.desbloquearSkin(Convert.ToInt32(botonPulsado.transform.parent.name)); //Selecciono el nombre del padre del boton pulsado y lo paso a int, así obtengo el id del skin desbloqueado
            CG.restarMonedas(price); //Resto las monedas
            
            botonPulsado.SetActive(false); //Desactivar boton de comprar skin
            botonPulsado.GetComponentInParent<Button>().interactable = true; //Ya se puede seleccionar la skin comprada

        }
        actualizarMonedas();
    }

    //Reinicia el nivel actual
    public void recargarElNivel()
    {
        nivel = Niveles.transform.Find("Nivel_" + _config.transform.GetComponent<ControladorGeneral>().getNivelSeleccionado());
        nivel.GetComponent<cargarNivel>().reiniciarElNivel();
    }
}