﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ControlSonidos : MonoBehaviour
{

    public GameObject SoundOn; //Imagen Sonido ON
    public GameObject SoundOff; //Imagen Sonido Off


    public void Awake()
    {
        playAmbientSound();
    }

    public void muteAllSounds() //Si muteo todos los sonidos
    {
        foreach(Transform child in transform) //Por cada sonido
        {
            child.GetComponent<AudioSource>().mute = true; //Muteado
        }
        SoundOff.SetActive(true); //Activo imagen sonido Off
        SoundOn.SetActive(false); //Desactivo imagen sonido On
    }

    public void unmuteAllSounds() //Si desmuteo todos los sonidos
    {
        foreach (Transform child in transform) //Por cada sonido
        {
            child.GetComponent<AudioSource>().mute = false; //Desmuteado
        }

        SoundOn.SetActive(true); //Activo imagen sonido ON
        SoundOff.SetActive(false); //Desactivo imagen sonido OFF
    }

    public void playMovimentSound() //Ejecuto sonido movimiento
    {
        transform.Find("Movimiento").GetComponent<AudioSource>().Play();
    }

    public void playAmbientSound()
    {
        transform.Find("Ambient").GetComponent<AudioSource>().Play();
    }

    public void playWinSound()
    {
        transform.Find("Win").GetComponent<AudioSource>().Play();
    }

}
