﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Movimiento_Plataforma : MonoBehaviour
{
    #region variables publicas
    public GameObject Player;
    public float velocidad;
    #endregion

    #region variables privadas
    private Transform posInicial;
    private Transform posFinal;
    private Transform plataforma;
    private float step;
    private bool iniciarMovimiento;
    private int direccion;
    //private float tiempoEntreAcciones;
    private float tiempoInicio;
    #endregion  

    // Start is called before the first frame update
    void Start()
    {
        posInicial = transform.Find("INICIO"); //Guardo la posicion inicial de la plataforma
        posFinal = transform.Find("FINAL"); //Guardo la posicion final de la plataforma
        plataforma = transform.Find("PLATAFORMA"); //Guardo el modelo de la plataforma
        //velocidad = 1f;
        iniciarMovimiento = false; //No se mueve
        direccion = 0; //Direccion inicial
        //tiempoEntreAcciones = 1f;
}

    // Update is called once per frame
    void Update()
    {
        if (iniciarMovimiento) //Cuando se puede mover
        {
            moverPlataforma(); //Mueve la plataforma
        }
    }

    #region #FUNCIONES#
    public void moverPlataforma()
    {
        step = velocidad * Time.deltaTime; //Marco la velocidad a la que se movera

        if (direccion == 0)
        {
            plataforma.position = Vector3.MoveTowards(plataforma.position, posFinal.position, step); //Muevo la plataforma desde la posicion actual hacia la final

            if (plataforma.position == posFinal.position) //Cuando la plataforma llega al objetivo se bloquea
            {
                iniciarMovimiento = false; //No se puede mover
                plataforma.tag = "Plataforma"; //Pongo el Tag en Plataforma
                Player.GetComponent<Movimiento_Jugador>().resetearMovimiento(); //Marco al player como que ya no esta encima la plataforma
                Player.transform.SetParent(null); //Le quito el "padre" que era la plataforma al player
                cambiarDireccion(); //Cambio la direccion para cuando se vuelva a subir
            }
        }
        else
        {
            plataforma.position = Vector3.MoveTowards(plataforma.position, posInicial.position, step);

            if (plataforma.position == posInicial.position) //Cuando la plataforma llega al objetivo se bloquea
            {
                iniciarMovimiento = false;  //No se puede mover
                plataforma.tag = "Plataforma";  //Pongo el Tag en Plataforma
                Player.GetComponent<Movimiento_Jugador>().resetearMovimiento();  //Marco al player como que ya no esta encima la plataforma
                Player.transform.SetParent(null); //Le quito el "padre" que era la plataforma al player
                cambiarDireccion(); //Cambio la direccion para cuando se vuelva a subir
            }
        }
        

    }

    private void cambiarDireccion() //Cambio la direccion en la que se movera la plataforma
    {
        if(direccion == 0)
        {
            direccion = 1;
        }
        else
        {
            direccion = 0;
        }
    }

    public void mover() //Inicia el movimiento de la plataforma
    {
        plataforma.tag = "Suelo";
        iniciarMovimiento = true;
    }

    public void pararMovimiento() //Bloquear el movimiento de la plataforma para que no continue moviendose
    {
        iniciarMovimiento = false;
        direccion = 0;
    }
    #endregion  
}
