﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class RotateAroundTarget : MonoBehaviour
{
    /* Script sencillo visto en https://answers.unity.com/ */
    /* Modificado para que apunte siempre al centro del Nivel*/

    #region variables privadas
    private float velocidadRotacion = 0.5f;//Velocidad de la rotación
    private Vector3 point;//La coordenada hacia donde apuntara la camara
    #endregion  
    // Start is called before the first frame update
    void Start()
    {
        selectNivel(); //Seleccion el nivel actual y apunto al cnetro
    }

    // Update is called once per frame
    void Update()
    {
        transform.RotateAround(point, new Vector3(0.0f, 1.0f, 0.0f), 20 * Time.deltaTime * velocidadRotacion); //Roto alrededor de point
    }

    public void selectNivel()
    {
        string nivel = "Nivel_" + GetComponentInParent<ControladorGeneral>().getNivelSeleccionado().ToString(); //Selecciono el nivel actual

        //Creo un grupo con todo el mapa del nivel//
        Bounds bounds = new Bounds();
        foreach(Transform child in transform.parent.gameObject.GetComponentInParent<Transform>().Find(nivel).gameObject.transform.Find("Mapa"))
        {
            bounds.Encapsulate(child.position);
        }

        //El centro del grupo es donde apuntara mi camara//
        point = bounds.center;
        point = new Vector3(point.x, point.y - 3, point.z); //Le resto -3 por que no quiero que apunte exactamente al centro

        transform.LookAt(point);//Hago que la camara apunte hacia el point
    }
}
