﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class cargarNivel : MonoBehaviour
{
    #region public variables
    public GameObject posicionInicial;
    public GameObject Player;
    #endregion

    #region private variables
    private string nombrePlataformaFinal = "PLATAFORMA";
    #endregion

    private void Start()
    {
        Player.SetActive(true); //Activo el jugador!
    }

    #region #FUNCIONES#

    //Recargo el jugador//
    public void reiniciarPlayer()
    {
        Player.GetComponent<Movimiento_Jugador>().resetearMovimiento(); //Indico que le pj no esta en movimiento
        Player.GetComponent<Movimiento_Jugador>().limpiarMovimientos(); //Elimino los movimentos guardados en la tabla movimientos
        Player.transform.SetParent(null); //Elimino el padre del player para resetear correctamente la posicion. (por si esta encima de una plataforma)
        Player.transform.position = posicionInicial.transform.position; //Reseteo la posicion a la posicion inicial
    }

    //Recargo las monedas//
    public void reiniciarMonedas()
    {

        foreach (Transform child in transform.Find("Monedas")) //Activa lo de dentro del GameObject Monedas
        {
            child.gameObject.SetActive(true); //Muestro cad moneda
        }
        Player.GetComponent<Controlar_PuntuacionNivel>().reiniciarMonedas(); //Reinicio el recuento de monedas
    }

    //Reinicio las plataformas del nivel//
    public void reiniciarPlataformas()
    {
        foreach (Transform child in transform.Find("Plataformas")) //Por cada plataforma
        {
            child.gameObject.GetComponent<Movimiento_Plataforma>().pararMovimiento(); //Paro el movimiento
            child.Find(nombrePlataformaFinal).transform.position = child.Find("INICIO").transform.position; //Reinicio la posicion
            child.Find(nombrePlataformaFinal).tag = "Plataforma"; //Le pongo el tag plataforma
        }
    }

    //Reinicio los botones del nivel//
   public void reiniciarBotones()
    {
        foreach (Transform child in transform.Find("Botones")) //Por cada boton
        {
            child.gameObject.GetComponent<Accion_Boton>().resetearPosicion(); //Reinicio la posicion de las puertas que controla
        }
    }

    //Reinicio el nivel//
    public void reiniciarElNivel()
    {
        reiniciarPlayer();
        reiniciarMonedas();
        reiniciarPlataformas();
        reiniciarBotones();
    }

    #endregion
}
